/*
* 基本図形(Sphere)への画像貼り付け
* use papervision3d
*/

package  {
	//必要なクラスのimport
	import flash.display.Sprite;
	import org.papervision3d.view.Viewport3D;
	import org.papervision3d.scenes.Scene3D;
	import org.papervision3d.cameras.Camera3D;
	import org.papervision3d.render.BasicRenderEngine;

	import org.papervision3d.objects.primitives.Sphere;
	import flash.events.Event;
	import org.papervision3d.materials.BitmapFileMaterial;

	public class Sample03 extends Sprite { //Spriteクラス継承
		public var viewport:Viewport3D;
		public var scene:Scene3D;
		public var camera:Camera3D;
		public var renderer:BasicRenderEngine;

		public var sphere:Sphere;

		//コンストラクタ
		public function Sample03() {
			init();//初期化関数開始
		}

		//初期化関数
		public function init(){
			viewport = new Viewport3D(550 , 400);
			addChild(viewport);//viewportを表示ツリーに追加

			renderer = new BasicRenderEngine();
			scene = new Scene3D();
			camera = new Camera3D();

			//BitmapFileMaterialには画像URLを引数として渡す
			sphere = new Sphere(new BitmapFileMaterial("http://www.aoharu-b.com/cgi/sk/img/study_p3d/papervision3d03back.jpg"));
			scene.addChild(sphere);

			addEventListener(Event.ENTER_FRAME , onEnterFrame);//ENTER_FRAMEイベント定義
		}

		//ENTER_FRAME時関数
		public function onEnterFrame(event:Event):void {
			sphere.yaw(5);//回転軸に沿って回転
			renderer.renderScene(scene, camera, viewport);//描画
		}
	}
}